//+------------------------------------------------------------------+
//|                                                 ViniI_MTF_ZZ.mq4 |
//|                     Copyright  2011, Victor Niclolaev aka Vinin |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Victor Niclolaev aka Vinin"
#property link      "vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 8

#property indicator_color8 Red         // M1
#property indicator_width8 1

#property indicator_color7 Orange      // M5
#property indicator_width7 1

#property indicator_color6 Yellow       // M15
#property indicator_width6 1

#property indicator_color5 Green       // M30
#property indicator_width5 1


#property indicator_color4 Red         // H1
#property indicator_width4 2

#property indicator_color3 DarkTurquoise   // H4
#property indicator_width3 3

#property indicator_color2 Blue       // D1
#property indicator_width2 3

#property indicator_color1 Purple        // W1
#property indicator_width1 4

//---- ZZ parameters
extern int _Depth = 12;
extern int _Dev = 5;
extern int _BStep = 3;

// Funcion Calculate ZZ
double ZZ( int period, int shift )
{
   return( iCustom( NULL, period, "ZigZag_Rosh", _Depth, _Dev, _BStep,  0, shift ) );
}


//---- indicator buffers
double M1_ZZ[], M5_ZZ[], M15_ZZ[], M30_ZZ[],H1_ZZ[], H4_ZZ[], D1_ZZ[], W1_ZZ[];

int TimeFrame[]={PERIOD_M1, PERIOD_M5, PERIOD_M15, PERIOD_M30, PERIOD_H1, PERIOD_H4, PERIOD_D1, PERIOD_W1};
int start=8;

int init()
{

   for( int i = 0; i < 8; i++)   {SetIndexStyle( i, DRAW_SECTION );SetIndexEmptyValue( i, 0.0 );}
   
   switch (Period()) {
      case (PERIOD_M1 ):    {SetIndexBuffer( 7, M1_ZZ ); SetIndexLabel(7,"M1");start--;}
      case (PERIOD_M5 ):    {SetIndexBuffer( 6, M5_ZZ ); SetIndexLabel(6,"M5");start--;}
      case (PERIOD_M15):    {SetIndexBuffer( 5, M15_ZZ); SetIndexLabel(5,"M15");start--;}
      case (PERIOD_M30):    {SetIndexBuffer( 4, M30_ZZ); SetIndexLabel(4,"M30");start--;}
      case (PERIOD_H1):     {SetIndexBuffer( 3, H1_ZZ ); SetIndexLabel(3,"H1");start--;}
      case (PERIOD_H4):     {SetIndexBuffer( 2, H4_ZZ ); SetIndexLabel(2,"H4");start--;}
      case (PERIOD_D1):     {SetIndexBuffer( 1, D1_ZZ ); SetIndexLabel(1,"D1");start--;}
      case (PERIOD_W1):     {SetIndexBuffer( 0, W1_ZZ ); SetIndexLabel(0,"W1");start--;}
   }

   IndicatorShortName( "ZigZag(" + _Depth + "," + _Dev + "," + _BStep + ")" );
   
   return( 0 );
}

int deinit()
{
   return( 0 );
}

//   ,   H1,      
int convertShift( int sh, int toTF )
{
   datetime time = Time[sh];
   return( iBarShift( NULL, toTF, time, true ) );
}



int start()
{
   int    counted_bars=IndicatorCounted();
   int i,j;
   int limit=Bars-counted_bars;
   if (!CheckHictory()) return(0);
   
   if (!CheckBars()) {
      limit=Bars-1;
   }

   
   for( i = limit; i >= 0; i-- ) {
      switch (Period()) {
         case (PERIOD_M1 ):    M1_ZZ[i] = Calc_ZZ(M1_ZZ,  0, i); if (M1_ZZ[i] ==0.0) break;
         case (PERIOD_M5 ):    M5_ZZ[i] = Calc_ZZ(M5_ZZ,  1, i); if (M5_ZZ[i] ==0.0) break;
         case (PERIOD_M15):    M15_ZZ[i]= Calc_ZZ(M15_ZZ, 2, i); if (M15_ZZ[i]==0.0) break;
         case (PERIOD_M30):    M30_ZZ[i]= Calc_ZZ(M30_ZZ, 3, i); if (M30_ZZ[i]==0.0) break;
         case (PERIOD_H1):     H1_ZZ[i] = Calc_ZZ(H1_ZZ,  4, i); if (H1_ZZ[i] ==0.0) break;
         case (PERIOD_H4):     H4_ZZ[i] = Calc_ZZ(H4_ZZ,  5, i); if (H4_ZZ[i] ==0.0) break;
         case (PERIOD_D1):     D1_ZZ[i] = Calc_ZZ(D1_ZZ,  6, i); if (D1_ZZ[i] ==0.0) break;
         case (PERIOD_W1):     W1_ZZ[i] = Calc_ZZ(W1_ZZ,  7, i); if (W1_ZZ[i] ==0.0) break;
      }
   }   
   
   return( 0 );
}

double Calc_ZZ(double & Array[], int Id, int pos){
   double Res;
   static double prevZZ[8][2];
   static int PrevTime[8];
   
   int shift=convertShift(pos,TimeFrame[Id]);
   Res=ZZ( TimeFrame[Id], shift );
   if (Res==0.0) return(0);
   if ((prevZZ[Id][1]-prevZZ[Id][0])*(prevZZ[Id][0]-Res)>=0) {
      shift=iBarShift(NULL, 0, PrevTime[Id]);
      Array[shift]=0;
      prevZZ[Id][0]=Res;
      PrevTime[Id]=Time[pos];
   } else {
      prevZZ[Id][1]=prevZZ[Id][0];
      prevZZ[Id][0]=Res;
      PrevTime[Id]=Time[pos];
   }
   return(Res);   
}


bool CompareDouble(double Value1, double Value2){ if (NormalizeDouble(Value1-Value2,Digits)==0) return(true); else return(false); }

bool CheckBars(){
   bool Res=true;
   static int PrevBars[]={0,0,0,0,0,0,0,0};
   for (int i=start;i<8;i++) {
      if (iBars(Symbol(), TimeFrame[i])>PrevBars[i]+1) {
         Res=false;
         PrevBars[i]=iBars(Symbol(), TimeFrame[i]);
      }
   }
   return(Res);
}

bool CheckHictory(){
   bool Res=true;
   int Error=GetLastError();
   for (int i=start;i<8;i++) {
      double tmp=iClose(Symbol(), TimeFrame[i],0);
      Error=GetLastError();
      if (Error==4066) Res=false;
   }
   return(Res);
}